package xyz.brassgoggledcoders.ballast.block;

import com.teamacronymcoders.base.blocks.IHasBlockStateMapper;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

import net.minecraft.block.BlockRailBase.EnumRailDirection;

public class BlockRailDiamondCrossing extends BlockRailFoundation implements IHasBlockStateMapper {
    public static final PropertyEnum<EnumRailDirection> SHAPE =
            PropertyEnum.func_177708_a("shape", EnumRailDirection.class, RailPredicates.FLAT_STRAIGHT::test);

    public BlockRailDiamondCrossing() {
        super("diamond_crossing");
    }

    @Override
    public EnumRailDirection getRailDirection(IBlockAccess world, BlockPos pos, IBlockState state, @Nullable EntityMinecart cart) {
        if (cart != null) {
            EnumFacing cartFacing = cart.func_174811_aO();
            if (cartFacing == EnumFacing.NORTH || cartFacing == EnumFacing.SOUTH) {
                return EnumRailDirection.EAST_WEST;
            }
        }
        return EnumRailDirection.NORTH_SOUTH;
    }

    @Override
    protected BlockStateContainer func_180661_e()
    {
        return new BlockStateContainer(this, SHAPE);
    }

    @Nonnull
    @Override
    public IProperty<EnumRailDirection> func_176560_l() {
        return SHAPE;
    }
}
