package xyz.brassgoggledcoders.ballast.block;

import com.teamacronymcoders.base.blocks.IHasBlockStateMapper;
import net.minecraft.block.Block;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import net.minecraft.block.BlockRailBase.EnumRailDirection;

public class BlockRailHolding extends BlockRailFoundation implements IHasBlockStateMapper {
    public static final PropertyBool NORTH_WEST = PropertyBool.func_177716_a("north_west");
    public static final PropertyEnum<EnumRailDirection> SHAPE = PropertyEnum.func_177708_a("shape", EnumRailDirection.class,
            RailPredicates.FLAT_STRAIGHT::test);
    public static final PropertyBool POWERED = PropertyBool.func_177716_a("powered");

    public BlockRailHolding() {
        super("holding");
        this.func_180632_j(this.func_176194_O().func_177621_b().func_177226_a(POWERED, false)
                .func_177226_a(SHAPE, EnumRailDirection.NORTH_SOUTH).func_177226_a(NORTH_WEST, true));
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand,
                                    EnumFacing facing, float hitX, float hitY, float hitZ) {
        if (!world.field_72995_K && player.func_184586_b(hand).func_190926_b()) {
            state = state.func_177226_a(NORTH_WEST, !state.func_177229_b(NORTH_WEST));
            world.func_180501_a(pos, state, 3);
            return true;
        }
        return false;
    }

    @Override
    public void onMinecartPass(World world, EntityMinecart cart, BlockPos pos) {
        IBlockState state = world.func_180495_p(pos);
        if (state.func_177229_b(POWERED)) {
            float speedIncrease = .5f;
            if (state.func_177229_b(NORTH_WEST)) {
                speedIncrease *= -1;
            }
            if (state.func_177229_b(SHAPE) == EnumRailDirection.NORTH_SOUTH) {
                cart.field_70179_y += speedIncrease;
            } else {
                cart.field_70159_w += speedIncrease;
            }
        } else {
            cart.field_70159_w = 0;
            cart.field_70181_x = 0;
            cart.field_70179_y = 0;
        }
    }

    @Override
    protected void func_189541_b(IBlockState state, World world, BlockPos pos, Block block) {
        boolean isStatePowered = state.func_177229_b(POWERED);
        boolean isWorldPowered = world.func_175640_z(pos);

        if (isWorldPowered != isStatePowered) {
            world.func_180501_a(pos, state.func_177226_a(POWERED, isWorldPowered), 3);
            world.func_175685_c(pos.func_177977_b(), this, true);
        }
        super.func_189541_b(state, world, pos, block);
    }

    @Override
    public boolean canMakeSlopes(IBlockAccess world, BlockPos pos) {
        return false;
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, SHAPE, POWERED, NORTH_WEST);
    }

    @Override
    @SuppressWarnings("deprecation")
    public IBlockState func_176203_a(int meta) {
        IBlockState blockState = this.func_176223_P();
        if (meta > 7) {
            meta = meta - 8;
            blockState = blockState.func_177226_a(POWERED, true);
        }
        if (meta % 2 != 0) {
            blockState = blockState.func_177226_a(NORTH_WEST, false);
        }
        if (meta > 1) {
            blockState = blockState.func_177226_a(SHAPE, EnumRailDirection.EAST_WEST);
        }

        return blockState;
    }

    @Override
    public int func_176201_c(IBlockState blockState) {
        int facing = blockState.func_177229_b(SHAPE) == EnumRailDirection.NORTH_SOUTH ? 0 : 2;
        facing += blockState.func_177229_b(NORTH_WEST) ? 0 : 1;
        int powered = blockState.func_177229_b(POWERED) ? 8 : 0;
        return facing + powered;
    }

    @Override
    public String getVariant(IBlockState blockState) {
        int facing = blockState.func_177229_b(SHAPE) == EnumRailDirection.NORTH_SOUTH ? 0 : 2;
        facing += blockState.func_177229_b(NORTH_WEST) ? 0 : 1;
        return "facing=" + EnumFacing.field_82609_l[facing + 2] + ",powered=" + blockState.func_177229_b(POWERED).toString();
    }

    @Override
    public IProperty<EnumRailDirection> func_176560_l() {
        return SHAPE;
    }
}
