package xyz.brassgoggledcoders.ballast.block;

import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import javax.annotation.Nonnull;

import net.minecraft.block.BlockRailBase.EnumRailDirection;

public class BlockRailWye extends BlockRailFoundation {
    public static final PropertyEnum<EnumRailDirection> SHAPE = PropertyEnum.func_177708_a("shape", EnumRailDirection.class,
            RailPredicates.ALL_CURVES::test);
    public static final PropertyBool SWITCHED = PropertyBool.func_177716_a("switched");

    public BlockRailWye() {
        super("wye");
        this.func_180632_j(this.field_176227_L.func_177621_b().func_177226_a(SHAPE, EnumRailDirection.SOUTH_EAST)
                .func_177226_a(SWITCHED, false));
    }

    @Override
    public boolean func_180639_a(World world, BlockPos pos, IBlockState state, EntityPlayer player, EnumHand hand,
                                    EnumFacing facing, float hitX, float hitY, float hitZ) {
        if (!world.field_72995_K && player.func_184586_b(hand).func_190926_b()) {
            if (state.func_177229_b(SWITCHED)) {
                int shapeValue = state.func_177229_b(SHAPE).func_177015_a() + 1;
                if (shapeValue > 9) {
                    shapeValue = 6;
                }
                state = state.func_177226_a(SHAPE, EnumRailDirection.func_177016_a(shapeValue));
            }

            state = state.func_177226_a(SWITCHED, !state.func_177229_b(SWITCHED));
            world.func_180501_a(pos, state, 3);
            return true;
        }
        return false;
    }

    @Override
    public boolean isFlexibleRail(IBlockAccess world, BlockPos pos) {
        return true;
    }

    @Override
    @SuppressWarnings("deprecation")
    public IBlockState func_176203_a(int meta) {
        IBlockState blockState = this.func_176223_P();
        blockState = blockState.func_177226_a(SHAPE, EnumRailDirection.func_177016_a(meta % 4 + 6));
        blockState = blockState.func_177226_a(SWITCHED, meta > 3);
        return blockState;
    }

    @Override
    public int func_176201_c(IBlockState blockState) {
        int meta = blockState.func_177229_b(SHAPE).func_177015_a() - 6;
        meta += blockState.func_177229_b(SWITCHED) ? 4 : 0;
        return meta;
    }

    @Override
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, SHAPE, SWITCHED);
    }

    @Nonnull
    @Override
    public IProperty<EnumRailDirection> func_176560_l() {
        return SHAPE;
    }
}
